You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

235 lines
5.3 KiB

  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-3.0+
  3. # Copyright (C) 2018, Martin Kepplinger <martink@posteo.de>
  4. RED='\033[0;31m'
  5. GREEN='\033[0;32m'
  6. NC='\033[0m'
  7. set -e
  8. IFDTOOL_PATH=./util/ifdtool/ifdtool
  9. ME_CLEANER_PATH=./util/me_cleaner/me_cleaner.py
  10. have_chipname=0
  11. have_backupname=0
  12. me_clean=0
  13. lock=0
  14. have_flasher=0
  15. usage()
  16. {
  17. echo "Skulls for the X230"
  18. echo " Run this script on an external computer with a flasher"
  19. echo " connected to the X230's bottom chip (farther away from"
  20. echo " the display, closer to you)."
  21. echo ""
  22. echo "Usage: $0 [-c <chipname>] [-a] [-m] [-k <backup_filename>] [-l]"
  23. echo ""
  24. echo " -f <hardware_flasher>"
  25. echo " supported flashers: rpi"
  26. echo ""
  27. echo " -c <chipname> flashrom chip description to use"
  28. echo " -m apply me_cleaner -S"
  29. echo " -l lock the flash instead of unlocking it"
  30. echo " -k <file> save the read image as <file>"
  31. }
  32. args=$(getopt -o f:mlc:k:h -- "$@")
  33. if [ $? -ne 0 ] ; then
  34. usage
  35. exit 1
  36. fi
  37. eval set -- "$args"
  38. while [ $# -gt 0 ]
  39. do
  40. case "$1" in
  41. -f)
  42. FLASHER=$2
  43. have_flasher=1
  44. shift
  45. ;;
  46. -m)
  47. me_clean=1
  48. ;;
  49. -l)
  50. lock=1
  51. ;;
  52. -c)
  53. CHIPNAME=$2
  54. have_chipname=1
  55. shift
  56. ;;
  57. -k)
  58. BACKUPNAME=$2
  59. have_backupname=1
  60. shift
  61. ;;
  62. -h)
  63. usage
  64. exit 1
  65. ;;
  66. --)
  67. shift
  68. break
  69. ;;
  70. *)
  71. echo "Invalid option: $1"
  72. usage
  73. exit 1
  74. ;;
  75. esac
  76. shift
  77. done
  78. if [ ! "$have_flasher" -gt 0 ] ; then
  79. echo "Skulls for the X230"
  80. echo ""
  81. echo "Please select the hardware you use:"
  82. PS3='Please select the hardware flasher: '
  83. options=("Raspberry Pi" "CH341A" "Exit")
  84. select opt in "${options[@]}"
  85. do
  86. case $opt in
  87. "Raspberry Pi")
  88. FLASHER="rpi"
  89. break
  90. ;;
  91. "CH341A")
  92. FLASHER="ch341a"
  93. break
  94. ;;
  95. "Exit")
  96. exit 0
  97. ;;
  98. *) echo invalid option;;
  99. esac
  100. done
  101. fi
  102. if [ "${FLASHER}" = "rpi" ] ; then
  103. echo "Ok. Run this on a Rasperry Pi."
  104. elif [ "${FLASHER}" = "ch341a" ] ; then
  105. echo "The CH341A is not yet supported"
  106. exit 0
  107. else
  108. exit 1
  109. fi
  110. hash flashrom || echo -e "${RED}Please install flashrom and run as root${NC}"
  111. TEMP_DIR=`mktemp -d`
  112. if [ ! "$have_chipname" -gt 0 ] ; then
  113. echo "trying to detect the chip..."
  114. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 &> ${TEMP_DIR}/chips || true
  115. flashrom_error=""
  116. flashrom_error=$(cat ${TEMP_DIR}/chips | grep -i error || true)
  117. if [ ! -z "${flashrom_error}" ] ; then
  118. usage
  119. echo "-------------- flashrom error: ---------------"
  120. cat ${TEMP_DIR}/chips
  121. rm -rf ${TEMP_DIR}
  122. exit 1
  123. fi
  124. CHIPNAME=""
  125. chip_found=0
  126. CHIPNAME=$(cat ${TEMP_DIR}/chips | grep Found | grep "MX25L6406E/MX25L6408E" | grep -o '".*"' || true)
  127. if [ ! -z "${CHIPNAME}" ] ; then
  128. chip_found=1
  129. fi
  130. CHIPNAME=$(cat ${TEMP_DIR}/chips | grep Found | grep "EN25QH64" | grep -o '".*"' || true)
  131. if [ ! -z "${CHIPNAME}" ] ; then
  132. chip_found=1
  133. fi
  134. if [ ! "$chip_found" -gt 0 ] ; then
  135. echo "chip not detected."
  136. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128
  137. rm -rf ${TEMP_DIR}
  138. echo "chip not detected. Please find it manually and rerun with the -c parameter."
  139. exit 1
  140. else
  141. echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
  142. fi
  143. fi
  144. hash make || echo -e "${RED}Please install make and a C compiler${NC}"
  145. make -C util/ifdtool
  146. if [ ! -e ${IFDTOOL_PATH} ] ; then
  147. echo "ifdtool not found at ${IFDTOOL_PATH}"
  148. exit 1
  149. fi
  150. if [ ! "$me_clean" -gt 0 ] ; then
  151. echo -e "Intel ME will ${RED}not${NC} be cleaned. Use -m if it should be."
  152. else
  153. echo -e "Intel ME will be ${GREEN}cleaned${NC}."
  154. fi
  155. if [ ! "$lock" -gt 0 ] ; then
  156. echo -e "The flash ROM will be ${GREEN}unlocked${NC}."
  157. else
  158. echo -e "The flash ROM will be ${RED}locked${NC}."
  159. fi
  160. if [ "$me_clean" -gt 0 ] ; then
  161. if [ ! -e ${ME_CLEANER_PATH} ] ; then
  162. echo "me_cleaner not found at ${ME_CLEANER_PATH}"
  163. rm -rf ${TEMP_DIR}
  164. exit 1
  165. fi
  166. fi
  167. echo "Start reading 2 times. Please be patient..."
  168. if [[ ! "$TEMP_DIR" || ! -d "$TEMP_DIR" ]]; then
  169. echo -e "${RED}Error:${NC} Could not create temp dir"
  170. rm -rf ${TEMP_DIR}
  171. exit 1
  172. fi
  173. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -r ${TEMP_DIR}/test1.rom
  174. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -r ${TEMP_DIR}/test2.rom
  175. cmp --silent ${TEMP_DIR}/test1.rom ${TEMP_DIR}/test2.rom
  176. if [ "$have_backupname" -gt 0 ] ; then
  177. cp ${TEMP_DIR}/test1.rom ${BACKUPNAME}
  178. echo "current image saved as ${BACKUPNAME}"
  179. fi
  180. reference_size=8388608
  181. TEMP_SIZE=$(wc -c <"$TEMP_DIR/test1.rom")
  182. if [ ! "$reference_size" -eq "$TEMP_SIZE" ] ; then
  183. echo -e "${RED}Error:${NC} didn't read 8M. You might be at the wrong chip."
  184. rm -rf ${TEMP_DIR}
  185. exit 1
  186. fi
  187. echo -e "${GREEN}connection ok${NC}"
  188. echo "start unlocking ..."
  189. if [ "$me_clean" -gt 0 ] ; then
  190. ${ME_CLEANER_PATH} -S -O ${TEMP_DIR}/work.rom ${TEMP_DIR}/test1.rom
  191. else
  192. cp ${TEMP_DIR}/test1.rom ${TEMP_DIR}/work.rom
  193. fi
  194. if [ ! "$lock" -gt 0 ] ; then
  195. ${IFDTOOL_PATH} -u ${TEMP_DIR}/work.rom
  196. else
  197. ${IFDTOOL_PATH} -l ${TEMP_DIR}/work.rom
  198. fi
  199. if [ ! -e ${TEMP_DIR}/work.rom.new ] ; then
  200. echo -e "${RED}Error:${NC} ifdtool failed. ${TEMP_DIR}/work.rom.new not found."
  201. rm -rf ${TEMP_DIR}
  202. exit 1
  203. fi
  204. if [ "$me_clean" -gt 0 ] ; then
  205. echo -e "${GREEN}ifdtool and me_cleaner ok${NC}"
  206. else
  207. echo -e "${GREEN}ifdtool ok${NC}"
  208. fi
  209. make clean -C util/ifdtool
  210. echo "start writing..."
  211. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -w ${TEMP_DIR}/work.rom.new
  212. rm -rf ${TEMP_DIR}
  213. echo -e "${GREEN}DONE${NC}"